SystemOrganization addCategory: #'Coral-IO'!

Object subclass: #CLITermcap
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-IO'!

CLITermcap class
	instanceVariableNames: 'instance'!

CLITermcap class
	instanceVariableNames: 'instance'!

!CLITermcap class methodsFor: 'class initialization' stamp: 'CamilloBruni 9/29/2011 18:31'!
initialize
	super initialize.
	instance := nil.! !

!CLITermcap class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/29/2011 18:30'!
instance
	^ instance ifNil: [ instance := self new ].! !

!CLITermcap methodsFor: 'initialize-release' stamp: 'CamilloBruni 2/7/2011 15:15'!
flush
	self halt.
	cache removeAll! !

!CLITermcap methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 2/7/2011 15:15'!
getent: aString
	<pPrimitive: #'tgetent:' plugin: #'IO.Term.Termcap'>
	self primitiveFailed! !

!CLITermcap methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 8/16/2010 15:25'!
getflag: aString
	<pPrimitive: #'tgetflag:' plugin: #'IO.Term.Termcap'>
	self primitiveFailed! !

!CLITermcap methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 8/16/2010 13:31'!
getnum: aString
	<pPrimitive: #'tgetnum:' plugin: #'IO.Term.Termcap'>
	self primitiveFailed! !

!CLITermcap methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/29/2011 18:32'!
getstr: aString
	^ cache at: aString ifAbsentPut: [(self tgetstr: aString) ifNil: [ '' ]]! !

!CLITermcap methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/29/2011 18:31'!
initialize
	|esc|
	
	cache := Dictionary new.
	esc := (Character escape asString), '['.
		
	cache at: #up put: (esc, 'A').
	cache at: #le put: (esc, 'D').
	cache at: #nd put: (esc, 'C').
	cache at: #im put: ''.
	cache at: #ei put: ''.
	cache at: #mr put: (esc, '7m').
	cache at: #me put: (esc, '0m').
	cache at: #ce put: (esc, 'K').
	cache at: #al put: (esc, 'L').
	cache at: #dl put: (esc, 'M').
	cache at: #cr put: (esc, String cr).! !

!CLITermcap methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 8/16/2010 16:33'!
parm: p1 in: string
	<pPrimitive: #'tparm:in:' plugin: #'IO.Term.Termcap'>
	self primitiveFailed! !

!CLITermcap methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 8/16/2010 16:33'!
parm: p1 parm: p2 in: string
	<pPrimitive: #'tparm:parm:in:' plugin: #'IO.Term.Termcap'>
	self primitiveFailed! !

!CLITermcap methodsFor: 'initialize-release' stamp: 'ToonVerwaest 8/16/2010 15:00'!
reset
	self getent: (PEnvironment instance at: #TERM ifAbsent: [ 'dumb' ])! !

!CLITermcap methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/29/2011 19:01'!
tgetstr: aString
	<pPrimitive: #'tgetstr:' plugin: #'IO.Term.Termcap'>
	self primitiveFailed! !

Object subclass: #CLIVTermInputDriver
	instanceVariableNames: 'inStream handler normal csi ss3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-IO'!

!CLIVTermInputDriver class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/29/2011 18:32'!
on: inputStream
	^ self new	
		inStream: inputStream;
		yourself! !

!CLIVTermInputDriver methodsFor: 'reading' stamp: 'CamilloBruni 8/11/2011 19:38'!
continueReadCSINumber: v
	| value character |
	value := v.
	[ $0 <= (character := inStream read) and: [ character <= $9 ]]
		whileTrue: [
			value := value * 10 + (character asInteger - $0 asInteger ) ].
	character = $~ ifFalse: [ self fail: character in: 'Control Sequence Introducer (number end)' ].
	^ csi at: value ifAbsent: [ self fail: character in: 'Control Sequence Introducer (number end)' ].! !

!CLIVTermInputDriver methodsFor: 'private' stamp: 'ToonVerwaest 8/13/2010 16:26'!
fail: value in: mode
	self warn: mode asString, ' does not support ', value asInteger! !

!CLIVTermInputDriver methodsFor: 'accessing' stamp: 'ToonVerwaest 8/20/2010 14:15'!
handler: anObject
	handler := anObject! !

!CLIVTermInputDriver methodsFor: 'accessing' stamp: 'CamilloBruni 8/11/2011 19:38'!
inStream: aStream
	inStream := aStream! !

!CLIVTermInputDriver methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/29/2011 18:32'!
initialize

	normal := Dictionary new.
	self initializeNormal: normal.
	
	ss3 := Dictionary new.
	self initializeSS3: ss3.
	
	csi := Dictionary new.
	self initializeCSI: csi! !

!CLIVTermInputDriver methodsFor: 'initialize-release' stamp: 'ToonVerwaest 8/20/2010 14:16'!
initializeCSI: actions
	actions at: $A put: [ handler up    ].
	actions at: $B put: [ handler down  ].
	actions at: $C put: [ handler right ].
	actions at: $D put: [ handler left  ].
	actions at: $E put: [ handler here  ].
	
	actions at: 1 put: [ handler find   ].
	actions at: 2 put: [ handler insert ].
	actions at: 3 put: [ handler remove ].
	actions at: 4 put: [ handler select ].
	actions at: 5 put: [ handler previousScreen ].
	actions at: 6 put: [ handler nextScreen ].
	
	actions at: 15 put: [ handler f5 ].
	actions at: 17 put: [ handler f6 ].
	actions at: 18 put: [ handler f7 ].
	actions at: 19 put: [ handler f8 ].
	actions at: 20 put: [ handler f9 ].
	actions at: 21 put: [ handler f10 ].
	actions at: 23 put: [ handler f11 ].
	actions at: 24 put: [ handler f12 ].
	actions at: 25 put: [ handler f13 ].
	actions at: 26 put: [ handler f14 ].
	actions at: 28 put: [ handler f15 ].
	actions at: 29 put: [ handler f16 ].
	actions at: 31 put: [ handler f17 ].
	actions at: 32 put: [ handler f18 ].
	actions at: 33 put: [ handler f19 ].
	actions at: 34 put: [ handler f20 ].
	
	actions at: $[ put: [ self readCSI ].! !

!CLIVTermInputDriver methodsFor: 'initialize-release' stamp: 'ToonVerwaest 8/20/2010 14:17'!
initializeNormal: actions
	actions at: 1 put: [ handler startOfHeading ].
	actions at: 2 put: [ handler startOfText ].
	actions at: 3 put: [ handler endOfText ].
	actions at: 4 put: [ handler endOfTransmission ].
	actions at: 5 put: [ handler enquiry ].
	actions at: 6 put: [ handler acknowledge ].
	actions at: 7 put: [ handler bell ].
	actions at: 8 put: [ handler backspace ].
	actions at: 9 put: [ handler tab ].
	actions at: 10 put: [ handler lf ].
	actions at: 11 put: [ handler verticalTab ].
	actions at: 12 put: [ handler formfeed ].
	actions at: 13 put: [ handler carriageReturn ].
	actions at: 14 put: [ handler shiftOut ].
	actions at: 15 put: [ handler shiftIn ].
	actions at: 27 put: [ self readC1 ].
	actions at: 127 put: [ handler delete ].! !

!CLIVTermInputDriver methodsFor: 'initialize-release' stamp: 'ToonVerwaest 8/20/2010 14:17'!
initializeSS3: actions
	actions at: $p put: [ handler keypad0 ].
	actions at: $q put: [ handler keypad1 ].
	actions at: $r put: [ handler keypad2 ].
	actions at: $s put: [ handler keypad3 ].
	actions at: $t put: [ handler keypad4 ].
	actions at: $u put: [ handler keypad5 ].
	actions at: $v put: [ handler keypad6 ].
	actions at: $w put: [ handler keypad7 ].
	actions at: $x put: [ handler keypad8 ].
	actions at: $y put: [ handler keypad9 ].
	
	actions at: $m put: [ handler keypadMinus ].
	actions at: $l put: [ handler keypadBacktick ].
	actions at: $n put: [ handler keypadDot ].
	actions at: $M put: [ handler keypadEnter ].
	
	actions at: $P put: [ handler f1 ].
	actions at: $Q put: [ handler f2 ].
	actions at: $R put: [ handler f3 ].
	actions at: $S put: [ handler f4 ].
	actions at: $H put: [ handler home ].
	actions at: $F put: [ handler end ].! !

!CLIVTermInputDriver methodsFor: 'reading' stamp: 'CamilloBruni 8/24/2011 16:19'!
read
	" C0 Control (Escape) mode "
	| character action |
	character := inStream next.
	character ifNil: [ Error signal: 'could not read character from input' ].
	action := normal
				at: character asInteger
				ifAbsent: [ ^ handler write: character ].
	action value! !

!CLIVTermInputDriver methodsFor: 'reading' stamp: 'CamilloBruni 8/11/2011 19:38'!
readC1
	" C1 Control Escape mode "
	| character |
	character := inStream read.
	character = $[ ifTrue: [ ^ self readCSI ].
	character = $O ifTrue: [ ^ self readSS3 ].
	handler alt: character! !

!CLIVTermInputDriver methodsFor: 'reading' stamp: 'CamilloBruni 8/11/2011 19:38'!
readCSI
	" Control Sequence Introducer mode "
	| code character action |
	character := inStream read.
	action := ($0 <= character and: [ character <= $9 ])
		ifTrue: [ self continueReadCSINumber: character asInteger - $0 asInteger ]
		ifFalse: [
			csi at: character ifAbsent: [
				self fail: character in: 'Control Sequence Introducer' ]].
	action value! !

!CLIVTermInputDriver methodsFor: 'reading' stamp: 'CamilloBruni 8/11/2011 19:38'!
readSS3
	" Single-Shift 3 mode "
	| character action |
	character := inStream read.
	action := ss3 at: character ifAbsent: [ self fail: character in: 'Single-Shift 3' ].
	action value! !

Object subclass: #CLIVTermOutputDriver
	instanceVariableNames: 'termcap outStream currentBackground currentColor light blink shouldEcho'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-IO'!

CLIVTermOutputDriver class
	instanceVariableNames: 'stdoutTerminalInstance stderrTerminalInstance'!

CLIVTermOutputDriver class
	instanceVariableNames: 'stdoutTerminalInstance stderrTerminalInstance'!

CLIVTermOutputDriver subclass: #CLISTVTermOutputDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-IO'!

!CLISTVTermOutputDriver methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 2/10/2011 13:33'!
nextPut: aCharacter
	^ self << aCharacter! !

!CLISTVTermOutputDriver methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 2/10/2011 13:06'!
nextPutAll: aString
	^ self << aString! !

!CLIVTermOutputDriver class methodsFor: 'instance-creation' stamp: 'CamilloBruni 9/29/2011 18:30'!
on: anOutputStream
	^ self new
		outStream: anOutputStream;
		yourself! !

!CLIVTermOutputDriver methodsFor: 'writing' stamp: 'CamilloBruni 2/8/2011 16:41'!
<< aString
	"self insertMode."
	outStream << aString.
	"self endInsertMode."! !

!CLIVTermOutputDriver methodsFor: 'removing' stamp: 'ToonVerwaest 8/12/2010 21:55'!
backspace
	outStream << Character backspace.
	self deleteCharacter ! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:52'!
black
	self color: 30.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:18'!
black: aString
	self black; << aString; flush; clear.! !

!CLIVTermOutputDriver methodsFor: 'highlighting' stamp: 'ToonVerwaest 8/16/2010 15:58'!
blinking
	outStream << (termcap getstr: 'mb')! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:46'!
blue
	self color: 34.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:18'!
blue: aString
	self blue; << aString; flush; clear.! !

!CLIVTermOutputDriver methodsFor: 'highlighting' stamp: 'ToonVerwaest 8/16/2010 15:59'!
bold
	" double bright mode "
	outStream << (termcap getstr: 'md')! !

!CLIVTermOutputDriver methodsFor: 'accessing' stamp: 'CamilloBruni 6/1/2010 00:06'!
clear
	self reset.
	self colorEscape.! !

!CLIVTermOutputDriver methodsFor: 'removing' stamp: 'ToonVerwaest 8/16/2010 16:37'!
clearFromBeginning
	outStream << (termcap getstr: 'cb')! !

!CLIVTermOutputDriver methodsFor: 'removing' stamp: 'CamilloBruni 2/7/2011 16:13'!
clearScreen
	outStream << (termcap getstr: 'cl')! !

!CLIVTermOutputDriver methodsFor: 'removing' stamp: 'ToonVerwaest 8/16/2010 16:37'!
clearToEnd
	outStream << (termcap getstr: 'ce')! !

!CLIVTermOutputDriver methodsFor: 'accessing' stamp: 'CamilloBruni 5/31/2010 23:57'!
color: aColor
	currentColor := aColor.
	self colorEscape.! !

!CLIVTermOutputDriver methodsFor: 'escaping' stamp: 'ToonVerwaest 8/16/2010 16:23'!
colorEscape
	self csiEscape.
	blink ifTrue: [ outStream << '5;' ].
	outStream << currentColor asString.
	(currentBackground == 0) ifFalse: [
		outStream << $; << currentBackground asString ].
	outStream << $m.! !

!CLIVTermOutputDriver methodsFor: 'accessing' stamp: 'ToonVerwaest 8/16/2010 16:09'!
columns
	^ termcap getnum: 'co'! !

!CLIVTermOutputDriver methodsFor: 'navigating' stamp: 'ToonVerwaest 8/16/2010 17:08'!
cr
	outStream << (termcap getstr: 'cr')! !

!CLIVTermOutputDriver methodsFor: 'escaping' stamp: 'ToonVerwaest 8/12/2010 17:00'!
csiEscape
	"Control Sequence Introducer escape"
	outStream << Character escape << $[! !

!CLIVTermOutputDriver methodsFor: 'cursor' stamp: 'ToonVerwaest 8/16/2010 15:52'!
cursorEnhanced
	outStream << (termcap getstr: 'vs')! !

!CLIVTermOutputDriver methodsFor: 'cursor' stamp: 'ToonVerwaest 8/16/2010 15:39'!
cursorInvisible
	outStream << (termcap getstr: 'vi')! !

!CLIVTermOutputDriver methodsFor: 'cursor' stamp: 'ToonVerwaest 8/16/2010 15:39'!
cursorNormal
	outStream << (termcap getstr: 've')! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:47'!
cyan
	self color: 36.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:19'!
cyan: aString
	self cyan; << aString; flush; clear.! !

!CLIVTermOutputDriver methodsFor: 'removing' stamp: 'ToonVerwaest 8/16/2010 15:40'!
deleteCharacter
	outStream << (termcap getstr: 'dc')! !

!CLIVTermOutputDriver methodsFor: 'removing' stamp: 'ToonVerwaest 8/16/2010 15:40'!
deleteLine
	outStream << (termcap getstr: 'dl')! !

!CLIVTermOutputDriver methodsFor: 'navigating' stamp: 'ToonVerwaest 8/16/2010 18:48'!
down
	self csiEscape.
	outStream << $B! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 6/14/2010 18:15'!
echo
	self echo: true.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 6/14/2010 18:15'!
echo: aBool
	shouldEcho = aBool ifTrue: [ ^ self ].
	shouldEcho := aBool.
	self enable: #echo.! !

!CLIVTermOutputDriver methodsFor: 'mode' stamp: 'ToonVerwaest 8/16/2010 16:39'!
endInsertMode
	outStream << (termcap getstr: 'ei')! !

!CLIVTermOutputDriver methodsFor: 'removing' stamp: 'ToonVerwaest 8/16/2010 16:33'!
erase
	outStream <<
		(termcap parm: '1' in:
			(termcap getstr: 'ec'))! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'ToonVerwaest 8/17/2010 14:01'!
errorColor 
	self red.
	self reverse! !

!CLIVTermOutputDriver methodsFor: 'escaping' stamp: 'ToonVerwaest 8/12/2010 17:00'!
escape
	outStream << Character escape! !

!CLIVTermOutputDriver methodsFor: 'writing' stamp: 'ToonVerwaest 8/6/2010 16:51'!
flush
	outStream flush.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:47'!
green
	self color: 32.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:19'!
green: aString
	self green; << aString; flush; clear.! !

!CLIVTermOutputDriver methodsFor: 'navigating' stamp: 'ToonVerwaest 8/12/2010 21:58'!
here
	self csiEscape.
	outStream << $E! !

!CLIVTermOutputDriver methodsFor: 'navigating' stamp: 'ToonVerwaest 8/16/2010 16:40'!
home
	outStream << (termcap getstr: 'ho')! !

!CLIVTermOutputDriver methodsFor: 'initialization' stamp: 'CamilloBruni 9/29/2011 18:30'!
initialize 
	super initialize.
	termcap := CLITermcap instance.
	self reset.! !

!CLIVTermOutputDriver methodsFor: 'inserting' stamp: 'ToonVerwaest 8/16/2010 15:42'!
insertCharacter
	outStream << (termcap getstr: 'ic')! !

!CLIVTermOutputDriver methodsFor: 'inserting' stamp: 'ToonVerwaest 8/16/2010 17:08'!
insertLine
	outStream << (termcap getstr: 'al').
	self cr.! !

!CLIVTermOutputDriver methodsFor: 'mode' stamp: 'ToonVerwaest 8/16/2010 16:35'!
insertMode
	outStream << (termcap getstr: 'im')! !

!CLIVTermOutputDriver methodsFor: 'highlighting' stamp: 'ToonVerwaest 8/16/2010 15:59'!
invisible
	outStream << (termcap getstr: 'mk')! !

!CLIVTermOutputDriver methodsFor: 'navigating' stamp: 'ToonVerwaest 8/16/2010 18:43'!
left
	outStream << (termcap getstr: 'le')! !

!CLIVTermOutputDriver methodsFor: 'writing' stamp: 'ToonVerwaest 8/6/2010 16:51'!
lf
	outStream lf! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:36'!
light
	light := true.! !

!CLIVTermOutputDriver methodsFor: 'accessing' stamp: 'ToonVerwaest 8/16/2010 16:09'!
lines
	^ termcap getnum: 'li'! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 6/14/2010 18:15'!
noEcho
	self echo: false.! !

!CLIVTermOutputDriver methodsFor: 'highlighting' stamp: 'ToonVerwaest 8/16/2010 15:58'!
normal
	outStream << (termcap getstr: 'me')! !

!CLIVTermOutputDriver methodsFor: 'accessing' stamp: 'CamilloBruni 5/31/2010 17:40'!
outStream
	^ outStream! !

!CLIVTermOutputDriver methodsFor: 'accessing' stamp: 'CamilloBruni 5/31/2010 17:40'!
outStream: stream
	outStream := stream.! !

!CLIVTermOutputDriver methodsFor: 'writing' stamp: 'ToonVerwaest 8/17/2010 14:27'!
overwrite: char
	outStream << char! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:48'!
pink
	self color: 35.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:19'!
pink: aString
	self pink; << aString; flush; clear.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:49'!
red
	self color: 31.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:19'!
red: aString
	self red; << aString; flush; clear.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'ToonVerwaest 8/16/2010 16:23'!
reset
	currentColor := 0.
	currentBackground := 0.
	light := false.
	blink := false.! !

!CLIVTermOutputDriver methodsFor: 'highlighting' stamp: 'ToonVerwaest 8/16/2010 16:42'!
reverse
	outStream << (termcap getstr: 'mr')! !

!CLIVTermOutputDriver methodsFor: 'navigating' stamp: 'ToonVerwaest 8/16/2010 18:43'!
right
	outStream << (termcap getstr: 'nd')! !

!CLIVTermOutputDriver methodsFor: 'scrolling' stamp: 'ToonVerwaest 8/16/2010 16:46'!
scrollBackward
	outStream << (termcap getstr: 'sr')! !

!CLIVTermOutputDriver methodsFor: 'scrolling' stamp: 'ToonVerwaest 8/16/2010 16:45'!
scrollForward
	outStream << (termcap getstr: 'sf')! !

!CLIVTermOutputDriver methodsFor: 'writing' stamp: 'ToonVerwaest 8/6/2010 16:59'!
space
	outStream space! !

!CLIVTermOutputDriver methodsFor: 'escaping' stamp: 'ToonVerwaest 8/13/2010 14:52'!
ss3Escape
	"Control Sequence Introducer escape"
	outStream << Character escape << $O! !

!CLIVTermOutputDriver methodsFor: 'writing' stamp: 'ToonVerwaest 8/6/2010 16:59'!
tab
	outStream tab! !

!CLIVTermOutputDriver methodsFor: 'highlighting' stamp: 'ToonVerwaest 8/16/2010 15:59'!
underline
	outStream << (termcap getstr: 'us')! !

!CLIVTermOutputDriver methodsFor: 'highlighting' stamp: 'ToonVerwaest 8/16/2010 15:54'!
underlineOff
	outStream << (termcap getstr: 'ue')! !

!CLIVTermOutputDriver methodsFor: 'navigating' stamp: 'ToonVerwaest 8/16/2010 18:43'!
up
	outStream << (termcap getstr: 'up')! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:50'!
white
	self color: 37.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:19'!
white: aString
	self white; << aString; flush; clear.! !

!CLIVTermOutputDriver methodsFor: 'accessing' stamp: 'CamilloBruni 6/1/2010 13:20'!
width
	! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 22:50'!
yellow
	self color: 33.! !

!CLIVTermOutputDriver methodsFor: 'coloring' stamp: 'CamilloBruni 5/31/2010 23:19'!
yellow: aString
	self yellow; << aString; flush; clear.! !
CLITermcap initialize!
